journaliment/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path("", include("recipes.urls")),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

recipes/urls.py
from django.urls import path, re_path

from . import views


urlpatterns = [
    path("", views.index, name="index"),
    path("signup", views.signup, name="signup"),
    path("edit", views.edit_profile, name="edit_profile"),

    path("commodity/<int:id>", views.commodity, name="commodity"),
    path("getcommodities", views.getcommodities),
    path("addcommodity", views.addcommodity),

    path("recipe/<int:id>", views.view_recipe, name="view_recipe"),
    path("edit_recipe/<int:id>", views.edit_recipe, name="edit_recipe"),
    path("add_to_favorites/<int:id>", views.add_to_favorites, name="add_to_favorites"),
    path("remove_from_favorites/<int:id>", views.remove_from_favorites, name="remove_from_favorites"),
]

recipes/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

UNIT_SYSTEMS = (
    ('IMPERIAL', 'imperial'),
    ('METRIC',   'metric'),
    ('GLOBAL',   'global')
)

UNIT_TYPES = (
    ('LENGTH', 'length'),
    ('MASS',   'mass'),
    ('VOLUME', 'volume'),
    ('OTHER',  'other')
)

ACTIVITY_LEVELS = (
    ('SEDENTARY',         'Little or no exercise, desk job'),
    ('LIGHTLY_ACTIVE',    'Light exercise/sports 1-3 days/week'),
    ('MODERATELY_ACTIVE', 'Moderate exercise/sports 6-7 days'),
    ('VERY_ACTIVE',       'Hard exercise every day, or 2 xs/day'),
    ('EXTRA_ACTIVE',      'Hard exercise 2 or more times per day'),
)

VEG_LEVELS = (
    ('NO', 'No'),
    ('OL', 'Ovo-lacto vegetarian'),
    ('O',  'Ovo vegetarian'),
    ('L',  'Lacto vegetarian'),
    ('V',  'Vegan'),
)

DIFFICULTY_LEVELS = (
    ('1',      'Easy'),
    ('2',   'Average'),
    ('3', 'Difficult'),
)

STATUSES = (
    ('ACTIVE', 'active'),
    ('DRAFT', 'draft'),
    ('REPORTED', 'reported')
)

class WeightHistory(models.Model):
    user            = models.ForeignKey(User, on_delete=models.SET_NULL, related_name='weight_user', null=True)
    weight          = models.DecimalField(max_digits=5, decimal_places=2)
    body_fat        = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)
    wdate           = models.DateTimeField(auto_now_add=True)

class Unit(models.Model):
    name            = models.CharField(max_length=30)
    abbrevation     = models.CharField(max_length=10)
    type            = models.CharField(max_length=6, default='OTHER', choices=UNIT_TYPES)
    unit_system     = models.CharField(max_length=8, choices=UNIT_SYSTEMS, default='METRIC')

    def __str__(self):
        return self.name

class Conversion(models.Model):
    from_unit       = models.ForeignKey(Unit, on_delete=models.CASCADE, related_name='from_unit')
    to_unit         = models.ForeignKey(Unit, on_delete=models.CASCADE, related_name='to_unit')
    multiplier      = models.FloatField(default=1)

class Commodity(models.Model):
    name            = models.CharField(max_length=127, default='', unique=True)
    per_piece       = models.BooleanField(default=False)
    cals            = models.PositiveIntegerField(null=True, blank=True, default=0, verbose_name="Calories")
    veg             = models.CharField(max_length=2, choices=VEG_LEVELS, null=True, blank=True, default=None, verbose_name="Vegetarian")
    protein         = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Protein")
    fat             = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Fat")
    carbs           = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Carbs")
    fiber           = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Fiber")
    sodium          = models.DecimalField(max_digits=7, decimal_places=2, null=True, blank=True, verbose_name="Sodium")
    verified        = models.IntegerField(default=0)
    unit_type       = models.CharField(max_length=6, default='MASS', choices=UNIT_TYPES)
    g_per_pc        = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)

    def __str__(self):
        return self.name

class Recipe(models.Model):
    user            = models.ForeignKey(User, on_delete=models.SET_NULL, related_name='author', null=True)
    created         = models.DateTimeField(auto_now_add=True)
    last_mod        = models.DateTimeField(auto_now=True)
    title           = models.CharField(max_length=255, default='')
    intro           = models.TextField(max_length=500, verbose_name='Introduction')
    notes           = models.TextField(max_length=2000, null=True, blank=True)
    prep_time       = models.PositiveIntegerField(default=0)
    cooking_time    = models.PositiveIntegerField(default=0)
    serves          = models.PositiveIntegerField(null=True)
    difficulty      = models.CharField(max_length=9, choices=DIFFICULTY_LEVELS, default='2')
    likes           = models.IntegerField(default=0)
    times           = models.PositiveIntegerField(default=0)
    cals            = models.PositiveIntegerField(null=True)
    protein         = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Protein (g/100g)")
    fat             = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Fat (g/100g)")
    carbs           = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Carbohydrate (g/100g)")
    fiber           = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True, verbose_name="Dietry Fiber (g/100g)")
    sodium          = models.DecimalField(max_digits=7, decimal_places=2, null=True, blank=True, verbose_name="Sodium (mg/100g)")
    veg             = models.CharField(max_length=2, choices=VEG_LEVELS, null=True, blank=True, default=None, verbose_name="Vegetarian")
    image           = models.ImageField(upload_to='images/', null=True, blank=True)
    status          = models.CharField(max_length=12, choices=STATUSES, default='DRAFT')

class Step(models.Model):
    recipe          = models.ForeignKey(Recipe, on_delete=models.CASCADE, related_name='s_recipe')
    step_order      = models.PositiveIntegerField(default=0)
    step_text       = models.TextField(max_length=1000)
    step_pic        = models.TextField(max_length=255, null=True, blank=True, default=None)

class Ingredient(models.Model):
    commodity       = models.ForeignKey(Commodity, on_delete=models.CASCADE, related_name='commodity')
    recipe          = models.ForeignKey(Recipe, on_delete=models.CASCADE, related_name='i_recipe')
    group           = models.PositiveSmallIntegerField(default=0)
    amount          = models.DecimalField(max_digits=5, decimal_places=2, null=True, default=0)
    unit            = models.ForeignKey(Unit, on_delete=models.CASCADE, related_name='unit')
    notes           = models.CharField(max_length=64, blank=True)

class Profile(models.Model):
    user            = models.OneToOneField(User, on_delete=models.CASCADE, related_name='profile')
    email           = models.EmailField(verbose_name="Email Address", unique=True)
    height          = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)
    weight          = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)
    body_fat        = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)
    target_weight   = models.DecimalField(max_digits=5, decimal_places=2, null=True, blank=True)
    target_calories = models.IntegerField(null=True, blank=True)
    last_updated    = models.DateTimeField(auto_now=True, blank=True)
    unit_system     = models.CharField(max_length=8, choices=UNIT_SYSTEMS, default='METRIC')
    activity        = models.CharField(max_length=17, choices=ACTIVITY_LEVELS, default='LIGHTLY_ACTIVE')
    favorites       = models.ManyToManyField(Recipe, blank=True, related_name="favroites")

@receiver(post_save, sender=User)
def update_user_profile(sender, instance, created, **kwargs):
    if created:
        Profile.objects.create(user=instance)
    instance.profile.save()

recipes/forms/commodity.py
from django import forms
from recipes.models import Commodity

class CommodityForm(forms.ModelForm):
    VEG_LEVELS = [('NO', 'No'),
                    ('OL', 'Ovo-lacto vegetarian'),
                    ('O',  'Ovo vegetarian'),
                    ('L',  'Lacto vegetarian'),
                    ('V',  'Vegan')]
    veg = forms.ChoiceField(choices=VEG_LEVELS)

    class Meta:
        model = Commodity
        fields = ('name', 'per_piece', 'cals', 'veg', 'protein', 'fat', 'carbs', 'fiber', 'sodium')

        def __init__(self, *args, **kwargs):
            super(Commodity, self).__init__(*args, **kwargs)
            self.fields['veg'].default = None
            self.fields['protein'].required = False
            self.fields['fat'].required = False
            self.fields['carbs'].required = False
            self.fields['fiber'].required = False
            self.fields['sodium'].required = False

recipes/forms/recipe.py
from django import forms
from recipes.models import Recipe

class RecipeForm(forms.ModelForm):
    ingredients = forms.CharField(required=False)
    steps = forms.CharField(required=False)

    class Meta:
        model = Recipe
        fields = ('title', 'image', 'intro', 'notes', 'prep_time', 'cooking_time', 'serves', 'difficulty')

        def __init__(self, *args, **kwargs):
            super(Commodity, self).__init__(*args, **kwargs)
            self.fields['intro'].required = False
            self.fields['notes'].required = False
            self.fields['protein'].required = False
            self.fields['fat'].required = False
            self.fields['carbs'].required = False
            self.fields['fiber'].required = False
            self.fields['sodium'].required = False
            self.fields['cals'].required = False
            self.fields['veg'].required = False
            self.fields['image'].required = False

recipes/views/account.py
from django.shortcuts import render, redirect
from django.contrib.auth import login, authenticate
from recipes.forms import SignUpForm, UpdateProfile
from recipes.models import Profile, WeightHistory
from recipes.views.index import get_conversions

def signup(request):
    if request.method == 'POST':
        form = SignUpForm(request.POST)
        if form.is_valid():
            user = form.save()
            user.refresh_from_db()  # load the profile instance created by the signal
            user.profile.email = form.cleaned_data.get('email')
            user.save()
            raw_password = form.cleaned_data.get('password1')
            user = authenticate(username=user.username, password=raw_password)
            login(request, user)
            return redirect('index')
    else:
        form = SignUpForm()

    return render(request, "registration/signup.html", {'form': form})

def edit_profile(request):
    request.session.set_expiry(1800)
    instance = Profile.objects.get(user = request.user)
    weights = get_weights(request.user)

    if request.method == 'POST':
        form = UpdateProfile(request.POST)
        if form.is_valid():
            profile = Profile.objects.get(user = request.user)
            profile.height = form.cleaned_data.get('height')
            profile.weight = form.cleaned_data.get('weight')
            profile.body_fat = form.cleaned_data.get('body_fat')
            profile.waist = form.cleaned_data.get('waist')
            profile.chest = form.cleaned_data.get('chest')
            profile.hips = form.cleaned_data.get('hips')
            profile.target_weight = form.cleaned_data.get('target_weight')

            profile.target_calories = form.cleaned_data.get('target_calories')
            profile.unit_system = form.cleaned_data.get('unit_system')
            profile.activity = form.cleaned_data.get('activity')
            profile.save()
            wh = WeightHistory(user = request.user, weight = form.cleaned_data.get('weight'), body_fat = form.cleaned_data.get('body_fat'))
            wh.save()
            return redirect('index')
    else:
        form = UpdateProfile(instance=instance)

    return render(request, "registration/edit.html", {'form': form, 'conversions': get_conversions(), 'weights': get_weights(request.user)})

def get_weights(user):
    weights = WeightHistory.objects.filter(user = user).order_by('wdate')
    weight_results = []
    for weight in weights:
        wght = {
            'weight': weight.weight,
            'body_fat': weight.body_fat,
            'date': weight.wdate.strftime("%Y-%m-%d")
            }
        weight_results.append(wght)

    return weight_results

recipes/views/commodity.py
from django.shortcuts import render, redirect
from django.http import JsonResponse
from recipes.forms import CommodityForm
from recipes.models import Commodity


def commodity(request, id):
    request.session.set_expiry(1800)
    if request.method == 'POST':
        form = CommodityForm(request.POST)
        if form.is_valid():
            commodity = Commodity()
            commodity.name = form.cleaned_data.get('name')
            commodity.cals = form.cleaned_data.get('cals')
            commodity.veg = form.cleaned_data.get('veg')
            commodity.protein = form.cleaned_data.get('protein')
            commodity.fat = form.cleaned_data.get('fat')
            commodity.carbs = form.cleaned_data.get('carbs')
            commodity.fiber = form.cleaned_data.get('fiber')
            commodity.sodium = form.cleaned_data.get('sodium')
            commodity.save()
            return redirect('index')
    else:
        try:
            instance = Commodity.objects.get(pk=id)
            form = CommodityForm(instance=instance)
        except:
            form = CommodityForm()

    return render(request, "recipes/commodity.html", {'cform': form})


def addcommodity(request):
    if request.method == 'POST':
        form = CommodityForm(request.POST)
        if form.is_valid():
            commodity = Commodity()
            commodity.name = form.cleaned_data.get('name')
            commodity.cals = form.cleaned_data.get('cals')
            commodity.veg = form.cleaned_data.get('veg')
            commodity.protein = form.cleaned_data.get('protein')
            commodity.fat = form.cleaned_data.get('fat')
            commodity.carbs = form.cleaned_data.get('carbs')
            commodity.fiber = form.cleaned_data.get('fiber')
            commodity.sodium = form.cleaned_data.get('sodium')
            commodity.save()

            commodity_response = {
                "id": commodity.pk,
                "name": commodity.name,
                "cals": commodity.cals,
                "veg": commodity.veg,
                "protein": commodity.protein,
                "fat": commodity.fat,
                "carbs": commodity.carbs,
                "fiber": commodity.fiber,
                "sodium": commodity.sodium
            }

            return JsonResponse({
                'commodity': commodity_response, 'status': 200
                })
        else:
            return JsonResponse({
                'error': 'Save commodity failed.', 'status': 400
                })


def getcommodities(request):
    if request.method == 'POST':
        search = request.POST.get('filter')
        comms = Commodity.objects.filter(name__icontains=search)
        res = []
        if comms:
            for item in comms:
                itm = {}
                itm.update({
                    "id": item.pk,
                    "name": item.name,
                    "cals": item.cals,
                    "veg": item.veg,
                    "protein": item.protein,
                    "fat": item.fat,
                    "carbs": item.carbs,
                    "fiber": item.fiber,
                    "sodium": item.sodium
                })
                res.append(itm)

        return JsonResponse({'data': res, 'status': 200})

recipes/views/index.py
from datetime import datetime, timezone
from django.shortcuts import render
from recipes.models import Conversion, Profile, Recipe, WeightHistory

def index(request):
    now = datetime.now(timezone.utc)
    profile_age = -1
    my_recipes = None
    last_20_recipe = None
    favs = None

    if request.user.is_authenticated:
        request.session.set_expiry(1800)
        prof = Profile.objects.get(user = request.user)
        last_updated = WeightHistory.objects.filter(user = request.user).order_by('wdate').reverse()
        if last_updated:
            profile_age = (now - last_updated[0].wdate).days
        my_recipes = Recipe.objects.filter(user = request.user).order_by('-id')
        favs = prof.favorites.all()
        last_20_recipe = Recipe.objects.filter(status='ACTIVE').exclude(user=request.user).order_by('-id')[:20]
    else:
        last_20_recipe = Recipe.objects.filter(status='ACTIVE').order_by('-id')[:20]

    return render(request, "recipes/index.html", {'profile_age': profile_age, 'recipes': last_20_recipe, 'my_recipes': my_recipes, 'favorites': favs})

def get_conversions():
    conversions_obj = Conversion.objects.all()

    if conversions_obj:
        response_data = {}

        for conv in conversions_obj:
            response_data[f"{conv.from_unit.abbrevation}_{conv.to_unit.abbrevation}"] = conv.multiplier

        return response_data
    else:
        return False

recipes/templates/recipes/base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
  <title>{% block title %}{% endblock %}Final project: Journaliment</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" type="text/css" href="{% static 'recipes/styles/app.css' %}">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
  <link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN" crossorigin="anonymous">
  <script>
  var csrf_token = '{{csrf_token}}';
  var profile_usys = '{% if user.profile.unit_system %}{{ user.profile.unit_system }}{% else %}METRIC{% endif %}'
  </script>
  <style>
  .cloak {
    display: none;
    opacity: 0;
    transform: opacity 1s;
  }
  </style>
</head>
<body class="{% block bodyclass %}{% endblock %}">
  {% include "recipes/menu.html" %}
  <header class="d-none d-lg-flex" style="background-image: url({% static 'recipes/images/header-bg.jpg' %})">
    <a class="navbar-brand" href="{% url 'index' %}">Final project: journALiment</a>
  </header>
  <div class="main-content">
    {% block body %}{% endblock %}
    {{ conversions|json_script:"conversion_data" }}
  </div>
  <footer>
    &copy; Final project, 2020
  </footer>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.26.0/moment.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/chart.js@2.9.3/dist/Chart.js"></script>
  <script src="{% static 'recipes/scripts/common.js' %}"></script>
  {% block scripts %}{% endblock %}
</body>
</html>

recipes/templates/recipes/commodity.html
{% extends "recipes/base.html" %}

{% block title %}
Commodity | 
{% endblock %}

{% block body %}
<div class="container">
{% if form.name.value == "" %}
<h1>Add commodity</h1>
{% else %}
<h1>Edit commodity</h1>
{% endif %}
  {% include 'recipes/commodity-form.html' %}
</div>
{% endblock %}

recipes/templates/recipes/edit-recipe.html
{% extends "recipes/base.html" %}

{% block title %}
Edit {{ recipe.title }} | 
{% endblock %}

{% block body %}
{% if ingredients %}
{{ ingredients|json_script:"ingredients_json" }}
{% endif %}
<div class="cloak">
  <div class="container">
    <div class="row">
      <aside class="col-12 col-lg-4">
        {% if form.image.value %}
        <div class="recipe-img-container" style="background-image: url(/media/{{ form.image.value }})"></div>
        {% endif %}
        <div class="container">
          {% include "recipes/recipe-ingredients.html" %}
        </div>
      </aside>
      <main class="col-12 col-lg-8">
        <div class="container">
          {% if form.title.value == "" %}
          <h1>Add recipe</h1>
          {% else %}
          <h1>Edit recipe</h1>
          {% endif %}
          <form method="post" class="recipe-form" method="post" enctype="multipart/form-data">
            <input type="hidden" name="ingredients" id="id_ingredients">
            <input type="hidden" name="steps" id="id_steps">
            <div class="row">
              {% csrf_token %}
              <div class="col-12">
                <div class="form-group row align-items-center">
                  <label class="col-12 col-lg-3 col-form-label">{{ form.title.label_tag }}</label>
                  <div class="col-12 col-lg-5">
                    <input type="text" id="id_title" name="title" value="{{ form.title.value }}" class="form-control">
                  </div>
                  <small class="text-muted title_help col-12 col-lg-4">Give a catchy title.</small>
                  {% for error in form.title.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-center">
                  <label class="col-3 col-form-label">{{ form.image.label_tag }}</label>
                  <div class="col-9">
                    <input type="file" class="form-control-file" id="id_image" name="image">
                  </div>
                  {% for error in form.image.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-start">
                  <label class="col-12 col-lg-3 col-form-label">{{ form.intro.label_tag }}</label>
                  <div class="col-12 col-lg-9">
                    <textarea id="id_intro" name="intro" class="form-control">{% if form.intro.value != None %}{{ form.intro.value }}{% endif %}</textarea>
                  </div>
                  {% for error in form.intro.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <h2>Steps</h2>
                <section class="steps-section">
                  <div id="steps_container">
                    {%if steps %}
                    {% for step in steps %}
                    <div class="form-group row align-items-start step-row">
                      <label class="col-1 col-form-label">{{ step.step_order }}.</label>
                      <div class="col-12 col-lg-11">
                        <textarea id="id_step_{{ step.step_order }}" name="step-{{ step.step_order }}" class="form-control step">{{ step.step_text }}</textarea>
                      </div>
                    </div>
                    {% endfor %}
                    {% else %}
                    <div class="form-group row align-items-start step-row">
                      <label class="col-1 col-form-label">1.</label>
                      <div class="col-11">
                        <textarea id="id_step_1" name="step-1" class="form-control step"></textarea>
                      </div>
                    </div>
                    {% endif %}
                  </div>
                  <button class="btn btn-primary col-12 offset-lg-1 col-lg-2" id="add-step">✚ Add step</button>
                  <small class="text-muted title_help col-8">Empty steps will be removed at save.</small>
                </section>
                <div class="form-group row align-items-start">
                  <label class="col-12 col-lg-3 col-form-label">{{ form.notes.label_tag }}</label>
                  <div class="col-12 col-lg-9">
                    <textarea id="id_notes" name="notes" class="form-control">{% if form.intro.value != None %}{{ form.notes.value }}{% endif %}</textarea>
                  </div>
                  {% for error in form.notes.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-center">
                  <label class="col-4 col-lg-3 col-form-label">{{ form.prep_time.label_tag }}</label>
                  <div class="input-group col-6 col-lg-3">
                    <input type="number" steps=1 id="id_prep_time" name="prep_time" value="{{ form.prep_time.value }}" class="form-control">
                    <div class="input-group-append">
                      <span class="input-group-text">min</span>
                    </div>
                  </div>
                  <div class="col-2 col-lg-4"></div>
                  {% for error in form.prep_time.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-center">
                  <label class="col-4 col-lg-3 col-form-label">{{ form.cooking_time.label_tag }}</label>
                  <div class="input-group col-6 col-lg-3">
                    <input type="number" steps=1 id="id_cooking_time" name="cooking_time" value="{{ form.cooking_time.value }}" class="form-control">
                    <div class="input-group-append">
                      <span class="input-group-text">min</span>
                    </div>
                  </div>
                  <div class="col-2 col-lg-4"></div>
                  {% for error in form.cooking_time.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-center">
                  <label class="col-4 col-lg-3 col-form-label">{{ form.serves.label_tag }}</label>
                  <div class="input-group col-4 col-lg-3">
                    <input type="number" steps=1 id="id_serves" name="serves" value="{{ form.serves.value }}" class="form-control">
                  </div>
                  <div class="col-3"></div>
                  {% for error in form.serves.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="form-group row align-items-center">
                  <label class="col-4 col-lg-3 col-form-label">{{ form.difficulty.label_tag }}</label>
                  <div class="col-8 col-lg-5">
                    <input type="range" min="1" max="3" steps=1 id="id_difficulty" name="difficulty" value="{{ form.difficulty.value }}" class="form-control">
                  </div>
                  <small class="text-muted title_help col-8 offset-4 col-lg-5 offset-lg-3 d-flex justify-content-between">
                    <span>Easy</span>
                    <span>Average</span>
                    <span>Difficult</span>
                  </small>
                  <div class="col-1"></div>
                  <div class="col-4"></div>
                  {% for error in form.difficulty.errors %}
                  <div class="alert alert-danger" role="alert">
                    {{ error }}
                  </div>
                  {% endfor %}
                </div>
                <div class="row btn-row-container justify-content-between">
                  <button type="submit" class="btn btn-primary" name="draft">Save draft</button>
                  <button type="submit" class="btn btn-success" name="publish">Publish</button>
                </div>
              </div>
            </div>

          </form>
        </div>
      </main>
    </div>
  </div>
</div>
<div class="modal" tabindex="-1" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title">Add commodity</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        {% include "recipes/commodity-form.html" %}
      </div>
    </div>
  </div>
</div>
{% endblock %}

recipes/templates/recipes/menu.html
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand d-block d-lg-none" href="{% url 'index' %}">Final project: journALiment</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active"><a class="nav-link" href="{% url 'index' %}">Home</a></li>
      {% if user.is_authenticated %}
      <li class="nav-item"><a class="nav-link" href="{% url 'edit_recipe' 0 %}">Add recipe</a><li>
      <li class="nav-item"><a class="nav-link" href="{% url 'edit_profile' %}">Hi, {{ user }}.</a><li>
      <li class="nav-item"><a class="nav-link" href="{% url 'logout' %}">Logout</a></li>
      <li class="session-counter"><span></span></li>
      {% else %}
      <li class="nav-item"><a class="nav-link" href="{% url 'signup' %}">Register</a></li>
      <li class="nav-item"><a class="nav-link" href="{% url 'login' %}">Login</a></li>
      {% endif %}
    </ul>
  </div>
</nav>